"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FormData = require("form-data");
const _source_converters_1 = require("./_source-converters");
const formdata = (fields, files) => {
    const data = new FormData();
    for (const field in fields) {
        if (fields.hasOwnProperty(field)) {
            const value = fields[field];
            if (value !== undefined) {
                data.append(field, String(value));
            }
        }
    }
    for (let i = 0; i < files.length; i++) {
        const file = files[i];
        data.append(file[0], file[1], { filename: file[0] });
    }
    return data;
};
function please(request) {
    if (request.type === 1) {
        if (typeof request.client.get === 'function') {
            return request.client.get(request.url).then(response => {
                response.resume();
            });
        }
        throw new Error(`Gotenberg client doesn't implements "get" method`);
    }
    const sources = _source_converters_1.toStreams(request.source);
    const form = formdata(request.fields, sources);
    return request.client.post(request.url, form);
}
exports.default = please;
