"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const page_1 = require("./page");
const noop = () => undefined;
exports.landscape = (fields) => (fields.landscape = true);
exports.portrait = (fields) => (fields.landscape = undefined);
function paperSize(paper) {
    if (!paper)
        return noop;
    return (fields) => {
        if (Array.isArray(paper)) {
            ;
            [fields.paperWidth, fields.paperHeight] = paper;
        }
        else {
            ;
            ({ width: fields.paperWidth, height: fields.paperHeight } = paper);
        }
    };
}
exports.paperSize = paperSize;
exports.a3 = paperSize(page_1.A3);
exports.a4 = paperSize(page_1.A4);
exports.a5 = paperSize(page_1.A5);
exports.a6 = paperSize(page_1.A6);
exports.legal = paperSize(page_1.LEGAL);
exports.letter = paperSize(page_1.LETTER);
exports.tabloid = paperSize(page_1.TABLOID);
function marginSizes(margins) {
    if (!margins)
        return noop;
    return (fields) => {
        if (Array.isArray(margins)) {
            ;
            [
                fields.marginTop,
                fields.marginRight,
                fields.marginBottom,
                fields.marginLeft,
            ] = margins;
        }
        else {
            ;
            ({
                top: fields.marginTop,
                right: fields.marginRight,
                bottom: fields.marginBottom,
                left: fields.marginLeft,
            } = margins);
        }
    };
}
exports.marginSizes = marginSizes;
exports.noMargins = marginSizes(page_1.NO_MARGINS);
exports.normalMargins = marginSizes(page_1.NORMAL_MARGINS);
exports.largeMargins = marginSizes(page_1.LARGE_MARGINS);
