"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _source_checkers_1 = require("./_source-checkers");
const _pipe_1 = require("./_pipe");
const _fields_1 = require("./_fields");
const _path_1 = require("./_path");
const _type_1 = require("./_type");
function url(request) {
    let remoteURL;
    if (_source_checkers_1.isString(request.source))
        remoteURL = request.source;
    else if (_source_checkers_1.isURL(request.source))
        remoteURL = request.source.toString();
    else {
        throw new Error('Invalid source, should be url string or instance of URL');
    }
    return _pipe_1.default(_fields_1.default({
        remoteURL,
        marginTop: 0,
        marginBottom: 0,
        marginLeft: 0,
        marginRight: 0,
    }), _path_1.default('/url'), _type_1.default(0))(Object.assign(Object.assign({}, request), { source: undefined }));
}
exports.default = url;
